<?php

$pluginData[freepay][type] = 'payment';
$pluginData[freepay][name] = 'فری پی';
$pluginData[freepay][uniq] = 'freepay';
$pluginData[freepay][description] = 'درگاه پرداخت اینترنتی فری پی';
$pluginData[freepay][author][name] = 'FreePay';
$pluginData[freepay][author][url] = 'http://freepay.ir';
$pluginData[freepay][author][email] = 'inbox@freepay.ir';
$pluginData[freepay][field][config][1][title] = 'اپی';
$pluginData[freepay][field][config][1][name] = 'api';

/*
 *
 * FreePay Class;
 *
*/
class freepaySys
{
	public $gateway_url = "http://freepay.ir/payment/";
	//public function __construct () {}
	public function paymentRequest ($parameters)
	{
		if(!is_array($parameters)) die('$parameters is not an array');
		$ch=curl_init();
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_URL, $this->gateway_url.'request');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HEADER,0);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($parameters));
		$res = curl_exec($ch);
		return json_decode($res);
	}
	public function paymentVerify ($parameters)
	{
		$ch=curl_init();
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_URL, $this->gateway_url.'verify');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HEADER,0);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($parameters));
		$res = curl_exec($ch);
		return json_decode($res);
	}
}

/*
 *
 * FreePay Gateway;
 *
*/
function gateway__freepay($data){
	global $config,$db,$smarty;
	$fpclient = new freepaySys();
	
	$parameters = array(
		'api' => trim($data[api]),
		'amount' => (int) ($data[amount]),
		'callback' => $data[callback],
		'host' => $_SERVER['SERVER_NAME']
	);
	$res = $fpclient->paymentRequest($parameters);
	if($res->type == 'success'){
	    $update[payment_rand] = $res->auth;
	    $sql = $db->queryUpdate('payment', $update, 'WHERE `payment_rand` = "' . $data[invoice_id] . '" LIMIT 1');
		$db->execute($sql);
		header("Location: ".$fpclient->gateway_url."gateway:".$res->auth);
		exit();
	}else{
	    $data[title] = 'خطای سیستم';
		$data[message] = '<font color="red">پیام سیستم : </font>' . $res->message . '<br /><a href="index.php" class="button">بازگشت</a>';
    	$query = 'SELECT * FROM `config` WHERE `config_id` = "1" LIMIT 1';
		$conf = $db->fetch($query);
		$smarty->assign('config', $conf);
		$smarty->assign('data', $data);
		$smarty->display('message.tpl');
	}
}

/*
 *
 * Freepay Callback;
 *
*/
function callback__freepay($data){
	global $db,$get;
	$fpclient = new freepaySys();
	
	$parameters = array(
		'api' => trim($data[api]),
		'authority' => (int) $_GET['authority']
	);
	$res = $fpclient->paymentVerify($parameters);
	
	if($res->status == 1 && $res->message == 'ok'){
		$sql = 'SELECT * FROM `payment` WHERE `payment_rand` = "' . $parameters['authority'] . '" LIMIT 1;';
		$payment = $db->fetch($sql);
		if($payment){
		  if ($payment[payment_status] == 1){
		    $output[status] = 1;
		    $output[res_num] = NULL;
		    $output[ref_num] = $parameters['authority'];
		    $output[payment_id]	= $payment[payment_id];
		  }else{
		    $output[status]  = 0;
		    $output[message] = 'وضعیت پرداخت تایید نشد: '.$payment[payment_status];
		  }
		}else{
		  $output[status]  = 0;
		  $output[message] = 'مشکل در دریافت اطلاعات';
		}
	}elseif($res->status == 1 && $res->message == 'comit'){
		// #########################################################
	}else{
	    $output[status]  = 0;
		$output[message] = $res->message;
	}
	return $output;
}

?>